/*
 * Copyright (c) 2002 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: property.c,v 1.2.2.1 2002/05/24 12:02:39 zinnia Exp $
 */

#include <stdio.h>
#include <string.h>

#include "drivers.h"
int toint(char* p){ return atoi(p);}
char* tostring(char* p){ return p; }

static flip_property* vector;

void flip_property_init(flip_property* _v){ vector = _v; }

int flip_set_property(char* key, char* val)
{
  flip_property* p;
  int result;
  for(p = vector; p->key != NULL; p++){
    if(strcasecmp(p->key, key) == 0){
      p->setter(val);
      return 1;
    }
  }
  return 0;
}

int flip_set_property_expression(char* e){
  char* key; char* value; char* p;
  key = (char*)strdup(e);
  value = NULL;
  for(p = key; *p != '\0'; p++){
    if(*p == '='){
      *p = '\0';
      value = p + 1;
    }
  }
  if(value == NULL) return 0;
  return flip_set_property(key, value);
}

void flip_print_property_list(FILE* fp)
{
  flip_property* p;
  for(p = vector; p->key != NULL; p++){
    fprintf(fp, "  %s: %s\n", p->key, p-> desc);
  }
  return;
}


